<?php
	#########################################################
	############### AUDIT LOG FUNCTIONS #####################
	#########################################################
	
	//	write_log("included OXYZ");	
	/*
	function write_log($log){		
		$timestamp = time();
		$datum = date("d.m.Y - H:i", $timestamp);		
		$file = 'hooks/ecomo.log';
		$current = file_get_contents($file);
		$current .= "\n".  $datum . " : ". $log ."\n";
		file_put_contents($file, $current);	
	}
	*/
	
	####### GET TABLE DATA BEFORE ANY CHANGES ########
	
	function table_before_change($TableName, $currentID, $tableID) {
		$_SESSION['before_change_sql'] ="";
		
		//original: show IDs of foreign keys
		//$fet=sql("SELECT * FROM $TableName WHERE $tableID = $currentID", $eo);
		
		//show values seen by the user
		// as suggested by pbötcher https://forums.appgini.com/phpbb/viewtopic.php?f=4&t=1369&p=10395#p10392
		$fields=get_sql_fields($TableName);
		$from=get_sql_from($TableName);
		$fet=sql("SELECT $fields FROM $from and $tableID = $currentID",$eo);
//write_log("SELECT $fields FROM $from and $tableID = $currentID");		

		$row = db_fetch_row($fet);
		// STORE THEM IN A SESSION VARIABLE FOR LATER COMPARISON
		$row = str_replace("\n", "<br/>", $row);
		$row = str_replace("'", "\'", $row);
		$_SESSION ['before_change_sql'] = $row; 
//write_log("rows: ".count($row));		
		return;
	}
	
	
	### GET CHANGES AND ADD TO AUDIT LOG ###
	
	function table_after_change($db_name, $TableName, $username, $userIP, $currentID, $tableID, $type){
		
		// GET ALL COLUMN NAMES IN THE TABLE
		/*
			$colnames = array(); // Create Empty Array
			$colquery =sql("SELECT `COLUMN_NAME` FROM `INFORMATION_SCHEMA`.`COLUMNS` WHERE `TABLE_SCHEMA`='$db_name' AND `TABLE_NAME`='$TableName'", $eo);
			
			$i = 0;
			while ($row = db_fetch_array($colquery)) {
			foreach($row as $key => $val) {
			$colnames[$i] = $val; }
			$i++; }
		*/
		$colnames = array();$i = 0;
		$query = sql("SHOW COLUMNS FROM $TableName", $eo);
		while($result = mysqli_fetch_assoc($query)):
		$colnames[$i] = $result['Field'];
		$i++;
		endwhile;
		
		
		
		// GET ARRAY OF VALUES AFTER CHANGE
		$_SESSION ['after_change_sql'] ="";
		
		//original: show IDs of foreign keys
		//$fet=sql("SELECT * FROM $TableName WHERE $tableID = $currentID", $eo);
		
		//show values seen by the user
		// as suggested by pbötcher https://forums.appgini.com/phpbb/viewtopic.php?f=4&t=1369&p=10395#p10392
		$fields=get_sql_fields($TableName);
		$from=get_sql_from($TableName);
		$fet=sql("SELECT $fields FROM $from and $tableID = $currentID",$eo);
//write_log("SELECT $fields FROM $from and $tableID = $currentID");		
		
		$row = db_fetch_row($fet);
		$row = str_replace("\n", "<br/>", $row);
		$row = str_replace("'", "\'", $row);
		$_SESSION ['after_change_sql'] = $row;
		
		// ARRAY OF ORIGINAL VALUES // ARRAY OF UPDATED VALUES
		$array1 = $_SESSION ['before_change_sql'];	$array2 = $_SESSION ['after_change_sql'];
		
		####### COMPARE BEFORE AND AFTER VALUES AND ADD CHANGED DATA ENTRIES TO AUDIT LOG #######
		
		$del="-DELETED-";
		$i = 0;
//write_log("count: ".count($array1));
		for ($i = 0; $i <= count($array1); ++$i) {
//write_log("a1[$i]: $array1[$i] // a2[$i]: $array2[$i]");	
			if ($array1[$i] != $array2[$i])
			{// Adds the INITIAL Values and CHANGED values to the auditlog database table
				
				switch (true) {
					// START Examples of how to exclude specific fields from being added to the audit Log
					case ($colnames[$i] == "editDate"):
					break;
					
					case ($colnames[$i] == "editedBy"):
					break;
					
					case ($colnames[$i] == "id_cnote"):
					break;
					
					case ($colnames[$i] == "Note"):
					break;
					
					case ($colnames[$i] == "fk_res"):
					break;
					// END of exclusion examples
					
					case ($type == "DELETION"):
					sql("INSERT INTO Auditor (res_id, username, ipaddr, time_stmp, change_type, table_name, fieldName, OldValue, NewValue) VALUES ('$currentID', '$username','$userIP',NOW(),'$type','$TableName','$colnames[$i]','$array1[$i]','$del')", $eo);
					break;
					
					default:
					sql("INSERT INTO Auditor (res_id, username, ipaddr, time_stmp, change_type, table_name, fieldName, OldValue, NewValue) VALUES ('$currentID', '$username','$userIP',NOW(),'$type','$TableName','$colnames[$i]','$array1[$i]','$array2[$i]')", $eo);
					break;
				}
				
			}
		}
		unset($_SESSION['before_change_sql']);
		unset($_SESSION['after_change_sql']);
		return;
	}
?>